#include <Xm/Xm.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h> 
#include <Xm/Form.h> 
#include <Xm/DialogS.h> 

Widget toplevel, field, pane, button;

void activate_callback(Widget w, XtPointer client_data, XtPointer call_data)
{
  XmTextFieldSetString(field, "Hello");
}

void makeform(Widget pane)
  {
  Widget Form,b1,b2;

  	Form = XmCreateForm(pane, "Form", NULL, 0);
  	b1 = XmCreatePushButton(Form,"bigbutton1",NULL,0);
  	XtVaSetValues(b1,
  		XmNtopAttachment, XmATTACH_FORM,
  		XmNbottomAttachment, XmATTACH_FORM,
  		XmNleftAttachment, XmATTACH_POSITION,
  		XmNleftPosition, 0,
  		XmNrightAttachment, XmATTACH_POSITION,
  		XmNrightPosition, 20,
  		NULL);
  	XtManageChild(b1);
  	b2 = XmCreatePushButton(Form,"bigbutton2",NULL,0);
  	XtVaSetValues(b2,
  		XmNtopAttachment, XmATTACH_FORM,
  		XmNbottomAttachment, XmATTACH_FORM,
  		XmNleftAttachment, XmATTACH_POSITION,
  		XmNleftPosition, 80,
  		XmNrightAttachment, XmATTACH_POSITION,
  		XmNrightPosition, 100,
  		NULL);
  	XtManageChild(b2);
  	XtManageChild(Form);
  }

void makebox(Widget pane)
  {
  Widget checkbox;

  checkbox = XmVaCreateSimpleCheckBox ( pane,"DetailCheckBox", NULL,
                              XmVaCHECKBUTTON, NULL, NULL, NULL, NULL,
                              XmVaCHECKBUTTON, NULL, NULL, NULL, NULL,
                              NULL );
  XtManageChild (checkbox);
  }


void callback(Widget W, int type)
{
Widget dialog,pane;
static int position = 0;

  switch (type)
  {
  case 1:
	  dialog = XmCreateDialogShell(toplevel,"FD",NULL,0);
	  break;
  case 2:
	  dialog = XmCreateFormDialog(toplevel,"FD",NULL,0);
	  /*
	  dialog = XmCreateBulletinBoardDialog(toplevel,"FD",NULL,0);
	  */
	  break;
  }

  pane = XtVaCreateWidget("pane", xmPanedWindowWidgetClass, dialog,
				 XmNsashHeight, 30,
                                 NULL);


  if (position / 2 * 2 == position)
  {
	  makebox(pane);
	  makeform(pane);
	  position = 1;
  }
  else
  {
	  makeform(pane);
	  makebox(pane);
	  position = 0;
  }

  XtManageChild(pane);
  XtManageChild(dialog);
}

int
main(int argc, char **argv)
{
  XtAppContext app;
  Widget pb;
  Widget Form;

  XtSetLanguageProc(NULL, NULL, NULL);

  toplevel = XtVaAppInitialize(&app,"Label",NULL,0,&argc,argv,NULL,NULL);

  Form = XmCreateForm(toplevel,"TopForm",NULL,0);

  pb = XmCreatePushButton(Form,"Bad",NULL,0);
  	XtVaSetValues(pb,
  		XmNtopAttachment, XmATTACH_FORM,
  		XmNbottomAttachment, XmATTACH_FORM,
  		XmNleftAttachment, XmATTACH_POSITION,
  		XmNleftPosition, 10,
  		XmNrightAttachment, XmATTACH_POSITION,
  		XmNrightPosition, 45,
  		NULL);
  XtAddCallback(pb,XmNactivateCallback,(void *)callback,(XtPointer)1);
  XtManageChild(pb);

  pb = XmCreatePushButton(Form,"Good",NULL,0);
  	XtVaSetValues(pb,
  		XmNtopAttachment, XmATTACH_FORM,
  		XmNbottomAttachment, XmATTACH_FORM,
  		XmNleftAttachment, XmATTACH_POSITION,
  		XmNleftPosition, 55,
  		XmNrightAttachment, XmATTACH_POSITION,
  		XmNrightPosition, 90,
  		NULL);
  XtAddCallback(pb,XmNactivateCallback,(void *)callback,(XtPointer)2);
  XtManageChild(pb);

  XtManageChild(Form);
  XtRealizeWidget(toplevel);
  XtAppMainLoop(app);

  exit(0);
}

